/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DATAFORMAT_H
#define DATAFORMAT_H

#include <time.h>

struct KEYBOARD_PRESS {
	int len;
	struct KEYBOARD_PRESS_RECORD * kpr;
};

struct MOUSE_PRESS {
	int len;
	struct MOUSE_PRESS_RECORD * mpr;
};

struct KEYBOARD_ETALON {
	int len;
	struct KEYBOARD_ETALON_RECORD * ker;
};

struct MOUSE_ETALON {
	int len;
	struct MOUSE_ETALON_RECORD * mer;
};

struct PFS {
	int len;
	struct PFS_RECORD * pr;
};

struct KEYBOARD_PRESS_RECORD {
	time_t current_time;
	int intensity;
	int key1;
	int retaining1;
	int space1;
	int key2;
	int retaining2;
};

struct MOUSE_PRESS_RECORD {
	time_t current_time;
	int intensity;
	int key;
	int retaining1;
};

struct KEYBOARD_ETALON_RECORD {
	int key1;
	int retaining1_min;
	int retaining1_max;
	int space1_min;
	int space1_max;
	int key2;
	int retaining2_min;
	int retaining2_max;
};

struct MOUSE_ETALON_RECORD {
	int key;
	int retaining1_min;
	int retaining1_max;
};

struct PFS_RECORD {
	time_t current_time;
	int intensity;
	double pfs;
	int device_id;
};

#endif
