/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#include "AbashinRuAngel.h"


void create_etalon(void) {
	char * buff = calloc(1, sizeof(char)*GLOBALBUFFSIZE);
	if (buff == NULL) return;

	sprintf(buff, "%s %s%s %s%s %s%s", PROGETALON,
		getenv("HOME"), SAVEDATA,
		getenv("HOME"), ETALONDATA,
		getenv("HOME"), ETALON);
	int result = system(buff);
	if (result) {
		free(buff);
		printf("Не найдена программа создания эталона.");
		return;
	}
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	free(buff);
}

void calculate_pfs(void) {
	char * buff = calloc(1, sizeof(char)*GLOBALBUFFSIZE);
	if (buff == NULL) return;
	sprintf(buff, "%s %s%s %s%s %s%s %s%s", PROGHUMANSTATUS,
		getenv("HOME"), SAVEDATA,
		getenv("HOME"), ETALON,
		getenv("HOME"), HUMANSTATUS,
		getenv("HOME"), HUMANSTATUSLOG);
	int result = system(buff);
	if (result)
		printf("Ошибка запуска программы определения ПФС.");
	free(buff);
}

void create_etalon_file(void) {
	char * buff = calloc(1, sizeof(char)*GLOBALBUFFSIZE);
	if (buff == NULL) return;
	sprintf(buff, "%s%s", getenv("HOME"), ETALON);
	FILE * f = fopen(buff,"r");
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	if (f == NULL) {
		sprintf(buff, "cp %s%s %s%s",
			getenv("HOME"), ETALONDEFAULT,
			getenv("HOME"), ETALON);
		int result = system(buff);
		if (result)
			printf("Скопирован файл эталона по-умолчанию.");
		bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	}
	else
		fclose(f);
	free(buff);
}

void create_catalog(void) {
	char * buff = calloc(1, sizeof(char)*GLOBALBUFFSIZE);
	if (buff == NULL) return;

	sprintf(buff, "%s%s", getenv("HOME"), ETALONDEFAULT);
	FILE * f = NULL;
	f = fopen(buff,"r");
	if (f == NULL) {
		int result = system("mkdir -p ~/.abashin.ru");
		if (result) {
			free(buff);
			return;
		}
	}
	fclose(f);
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	free(buff);
}

void tic_tac_action() {
	char * buff = calloc(1, sizeof(char)*GLOBALBUFFSIZE);
	if (buff == NULL) return;

	calculate_pfs();

	sprintf(buff, "%s %s%s", PROGHUMANSTATUSREPORT,
		getenv("HOME"), HUMANSTATUSLOG);
	int result = system(buff);
	if (result)
		printf("Не запущен файл создания отчета о состоянии человека.");
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);

	sprintf(buff, "%s %s%s", PROGSTATUSLOGSEND,
		getenv("HOME"), HUMANSTATUSLOG);
	result = system(buff);
	if (result)
		printf("Протокол состояний человека на сервер отправлен не был.");
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	free(buff);
}

void data_move(void) {
	char * buff = calloc(1, sizeof(char)*GLOBALBUFFSIZE);
	if (buff == NULL) return;
	FILE * fr = NULL;
	FILE * fw = NULL;

	fr = fopen(KEYBOARDETALONFILENAME, "r");
	if (fr == NULL) {
		free(buff);
		return;
	}
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	sprintf(buff, "%s%s", getenv("HOME"), SAVEDATA);
	fw = fopen(buff, "a");
	bzero(buff, sizeof(char)*GLOBALBUFFSIZE);
	free(buff);
	if (fw == NULL) {
		fclose(fr);
		return;
	}
	char buffer [BUFFERSIZE] = {0};
	fprintf(fw, "0 %ld\n", time(NULL));

	while (fgets(buffer,BUFFERSIZE,fr) != NULL)
		fprintf(fw, "1 %s", buffer);
	fclose(fr);

	fr = fopen(MOUSEETALONFILENAME, "r");
	if (fr == NULL) {
		fclose(fw);
		return;
	}
	while (fgets(buffer,BUFFERSIZE,fr) != NULL)
		fprintf(fw, "2 %s", buffer);
	fclose(fr);
	fclose(fw);
}
