/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ABASHINRUDBAPI_H
#define ABASHINRUDBAPI_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "../DataFormat.h"

int get_etalon(char * etalon_filename, struct MOUSE_ETALON ** me,
		struct KEYBOARD_ETALON ** ke);
int get_pfs_day(char * etalon_filename, struct PFS ** pfs,
		time_t start_time, time_t stop_time);

void how_much_etalon_record(char * etalon_filename, int * mouse_press_max,
		int * keyboard_press_max);
void how_much_pfs_record(char * filename, int * pfs_max, time_t start_time,
							time_t stop_time);

int add_log_pfs(struct PFS_RECORD * pfsr, char * filename);
int rewrite_current_pfs(struct PFS_RECORD * pfsr, char * filename);
int get_last_pfs(struct PFS_RECORD * pfsr, char * filename);

int get_input_device_data (char * etalondata, struct MOUSE_PRESS * mouse_press,
		struct KEYBOARD_PRESS * keyboard_press, time_t start,
		time_t stop);

int save_etalon (char * filename_temp, char * filename,
		struct MOUSE_ETALON * me, struct KEYBOARD_ETALON * ke);

#endif
