/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ABASHINRUETALON_H
#define ABASHINRUETALON_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "../DataFormat.h"
#include "../database/AbashinRuDbApi.h"

#define BUFFERSIZE 300
#define ETALONTEMP "/tmp/abashin.ru.etalon.temp"

#define MIN_INTENSITY_KEYBOARD 10
#define MIN_INTENSITY_MOUSE 10

void create_etalon(int massive_size, char * etalondata, char * etalon_filename);

int calculate_and_save_etalon (struct MOUSE_PRESS * mp, int min_intensity_mouse,
		struct KEYBOARD_PRESS * kp, int min_intensity_keyboard,
		int massive_size, char * etalon_filename);

void calc_mouse_etalon(struct MOUSE_PRESS * mouse_press,
		struct MOUSE_ETALON * me, int min_intensity);

void calc_keyboard_etalon(struct KEYBOARD_PRESS * keyboard_press,
		struct KEYBOARD_ETALON * ke, int min_intensity);

#endif
