/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ABASHINRUREPORT_H
#define ABASHINRUREPORT_H

#include "../DataFormat.h"
#include "../database/AbashinRuDbApi.h"

#define REPORTFILE "/.abashin.ru/abashin.ru.html"
#define MESSAGETYPEOUTPUT "Input information / Communication"
#define MESSAGETYPEINPUT "Obtaining information / Information processing"
#define MESSAGETYPEREST "Rest"

#define MIN_REST_LENGTH 9
#define MIN_REST_INTENSITY 10

struct REPORT_RECORD {
	time_t start_time;
	time_t stop_time;
	int intensity;
	char rest_or_work;
	double pfs;
	int pfs_count;
};

struct REPORT {
	int len;
	struct REPORT_RECORD * rr;
};


void get_earth_day (time_t current_time, time_t * begin_time,
	time_t * end_time);
void warning (char type);
int when_a_break (struct PFS * pfs, time_t current_time);
char * min_to_hm (const time_t period, char * buffer);
void pfs_to_report_record (struct PFS * pfs, struct REPORT **rep);
void print_report (struct PFS * pfs, char * filename,
					time_t current_time);
void delete_1struct(struct REPORT * rep, int number);
void merge_rest_record(struct REPORT * rep);
void merge_work_record(struct REPORT * rep);
void merge_Xminutlimit(struct REPORT * rep, int limit);
void merge_period_record(struct REPORT * rep);

char * create_report_string(struct REPORT_RECORD * rep_rec, char * report_string);
char * switch_color(char * buffer, time_t t_delta, double pfs);


#endif
