/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include "AbashinRuReport.h"


void debug_pfs(struct PFS * pfs) {
	if (pfs == NULL || pfs->len < 1) {
		puts("pfs не содержит элементов.");
		return;
	}
	int count = 0;
	for ( ; count < pfs->len; count++) {
		if (pfs->pr[count].current_time > 0)
			printf("%ld %d %lf %d\n",
				pfs->pr[count].current_time,
				pfs->pr[count].intensity,
				pfs->pr[count].pfs,
				pfs->pr[count].device_id);
	}
}


int main (int argc, char * argv[]) {
	if (argc != 2) return 0;
	char * PFSLOG = argv[1];

	time_t current_time = time(NULL);
	time_t begin_time = 0;
	time_t end_time = 0;
	get_earth_day(current_time, &begin_time, &end_time);

	struct PFS * pfs = NULL;

	get_pfs_day(PFSLOG, &pfs, begin_time, end_time);

	char * filename = calloc(500, sizeof(char));
	strcpy(filename, getenv("HOME"));
	strcat(filename, "/.abashin.ru");
	strcat(filename, "/report.html");
	print_report (pfs, filename, current_time);

	free(pfs);

	return 0;
}
