/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ABASHINRUSTATUS_H
#define ABASHINRUSTATUS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "../DataFormat.h"
#include "../database/AbashinRuDbApi.h"

#define CURDATASIZE 4000
#define PFS_STABILITY 360

struct MOUSE_PRESS * mouse_press;
struct KEYBOARD_PRESS * keyboard_press;

struct MOUSE_ETALON * me;
struct KEYBOARD_ETALON * ke;

double calc_sign(int value, int min, int max);

void calculate_mouse (struct PFS_RECORD * pfsr_current,
	struct MOUSE_ETALON * me, struct MOUSE_PRESS * md,
	int * intensity_m, double * pfs_m);

void calculate_keyboard (struct PFS_RECORD * pfsr_current,
	struct KEYBOARD_ETALON * ke, struct KEYBOARD_PRESS * kp,
	int * intensity_k, double * pfs_k);

void calculate_pfs (struct PFS_RECORD * pfsr_previous,
	struct PFS_RECORD * pfsr_current, struct MOUSE_ETALON * me,
	struct KEYBOARD_ETALON * ke, struct MOUSE_PRESS * md,
	struct KEYBOARD_PRESS * kp);

#endif
