/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#include "AbashinRuStatus.h"


int main (int argc, char * argv[]) {
	if (argc != 5) {
		puts("Переданы неправильные параметры.");
		return 0;
	}
	char * SAVEDATA = argv[1];
	char * ETALON = argv[2];
	char * HUMANSTATUSLAST = argv[3];
	char * HUMANSTATUSLOG = argv[4];
	char * path = calloc(150, sizeof(char));

	struct MOUSE_ETALON * me = NULL;
	struct KEYBOARD_ETALON * ke = NULL;

	get_etalon(ETALON, &me, &ke);

	struct MOUSE_PRESS * cdm = calloc(1, sizeof(struct MOUSE_PRESS));
	cdm->len = 10000;
	cdm->mpr = calloc(cdm->len, sizeof(struct MOUSE_PRESS_RECORD));

	struct KEYBOARD_PRESS * cdk = calloc(1, sizeof(struct KEYBOARD_PRESS));
	cdk->len = 10000;
	cdk->kpr = calloc(cdk->len, sizeof(struct KEYBOARD_PRESS_RECORD));


	time_t stop_time = time(NULL);
	time_t start_time = stop_time - PFS_STABILITY;
	get_input_device_data(SAVEDATA, cdm, cdk, start_time, stop_time);

	struct PFS_RECORD pfsr_previous = {0};
	struct PFS_RECORD pfsr_current = {0};

	get_last_pfs(&pfsr_previous, HUMANSTATUSLAST);

	calculate_pfs (&pfsr_previous, &pfsr_current, me, ke, cdm, cdk);

	rewrite_current_pfs(&pfsr_current, HUMANSTATUSLAST);

	add_log_pfs(&pfsr_current, HUMANSTATUSLOG);

	free(path);
	if (me) {
		free(me->mer);
		free(me);
	}
	if (ke) {
		free(ke->ker);
		free(ke);
	}
	if (cdm) {
		free(cdm->mpr);
		free(cdm);
	}
	if (cdk) {
		free(cdk->kpr);
		free(cdk);
	}

	return 0;
}
