/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#include "libdevice.h"

void clean_up_child_process(int signal_number) {
	sig_num = signal_number;
	pthread_create(&ptwaiter_id, NULL, &waiter, NULL);
}

void * waiter(void * empty) {
	int status;
	wait(&status);
	child_exit_status = status;
	return empty;
}

void reset_file(char * filename) {
	FILE * file = fopen(filename,"w");
	if (file == NULL) {
		fprintf(stderr, "Can`t create temp file.\n");
		return;
	}
	fclose(file);
}

void start_signal_handler(void) {
	struct sigaction sigchld_action = {0};
	sigchld_action.sa_handler = &clean_up_child_process;
	sigaction (SIGCHLD, &sigchld_action, NULL);
}

void send_data() {
	/* Отправкой данных эталона занимается пользовательское приложение */
}

void create_temp_file(char * base_filename, char * tempfilename) {
	strcpy(tempfilename, base_filename);
	srand(time(NULL));
	char rand_part[50] = {0};
	sprintf(rand_part, "%d", rand());
	strcat(tempfilename, rand_part);
	FILE * temp_file = fopen(tempfilename,"w");
	if (temp_file == NULL) {
		fprintf(stderr, "Can`t create temp file.\n");
		return;
	}
	fclose(temp_file);
	chmod(tempfilename, 0700);
}
