/*Copyright (C) 2020 Abashin Valerii Gennadievich <valeriy@abashin.ru>

This file is part of abashin.ru software.

Abashin.ru is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Abashin.ru is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Abashin.ru. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DATABASE_H
#define DATABASE_H

#include <dirent.h>
#include <linux/input.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h> /* mkstemp() (POSIX, BSD) */
#include <signal.h>
#include <string.h>
#include <strings.h> /* bzero */
#include <signal.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h> /* getpid */

sig_atomic_t child_exit_status;
pthread_t ptwaiter_id;
int sig_num;

void start_signal_handler(void);
void clean_up_child_process(int signal_number);
void * waiter(void * empty);

void create_temp_file(char * base_filename, char * tempfilename);
void send_data(void);
void reset_file(char * filename);

#endif
